import { Interrupt } from "./constants.js";
export declare class GraphRecursionError extends Error {
    constructor(message?: string);
    static get unminifiable_name(): string;
}
export declare class GraphValueError extends Error {
    constructor(message?: string);
    static get unminifiable_name(): string;
}
export declare class GraphInterrupt extends Error {
    interrupts: Interrupt[];
    constructor(interrupts?: Interrupt[]);
    static get unminifiable_name(): string;
}
/** Raised by a node to interrupt execution. */
export declare class NodeInterrupt extends GraphInterrupt {
    constructor(message: string);
    static get unminifiable_name(): string;
}
export declare function isGraphInterrupt(e?: GraphInterrupt | Error): e is GraphInterrupt;
export declare class EmptyInputError extends Error {
    constructor(message?: string);
    static get unminifiable_name(): string;
}
export declare class EmptyChannelError extends Error {
    constructor(message?: string);
    static get unminifiable_name(): string;
}
export declare class InvalidUpdateError extends Error {
    constructor(message?: string);
    static get unminifiable_name(): string;
}
